%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% (c) Hossam A.  H.  Fahmy 
%
%    This work may be distributed and/or modified under the
%    conditions of the LaTeX Project Public License, either version 1.3
%    of this license or (at your option) any later version.
%    The latest version of this license is in
%      http://www.latex-project.org/lppl.txt
%    and version 1.3 or later is part of all distributions of LaTeX
%    version 2005/12/01 or later.
%
% This work has the LPPL maintenance status `maintained'.
%
% The Current Maintainer of this work is Hossam A. H. Fahmy.
% (hfahmy@arith.stanford.edu)
%
% This work consists of all the files listed in alqalam_manifest.txt.
% 
% Based on the original work of the arabtex package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 21 Ramadan 1428, 3 Oct 2007
%**********************
% qmargin.sty
%**********************
% 4 july 2006
% our work added on this package
% Based on the orignal work of Hazrat Pradipta
% the original package name Harabmargin.sty
%***********************************************************************
% what we do using Pradipta package
% 1- we added \sajda function 
% 2- we didnot use the functions \rub & \sajda directly in the input file
%    but we use the unicode for that
% 3- rub3 elhizb code:  ^^db^^9e
%    sajda code:        ^^db^^a9 
% 4- we saved qamargin as utf8 as we typeset hizb word in arabic
% 5- we can merge sajda with rub elhizb using parameter \ifsajda
% 6- we raise rub elhizb words to be centered around the base line
%***********************************************************************
% The original work of Pradipta.
% dipta said:
%*************
% this package is used to provide a margin to take note about hizb and juz in quran.
% here we use temp variable since we can't use "\advance \global\juz by 1"
% so instead of using advance directly, we use temp variable
% (because we can't change the variable inside the group directly)
% Also, instead of using \ifthenelse from latex, we use the more basic command from tex (if)
% problem found : 
% 1. we can't put the writing (in the margin) in the justified style.
% 2. margin writing and the symbol "@" is not in the same line
% 3. we can't use "~" as a command in arabtex. It will cause problem when "@" is in the end of line
% try to fixed them, but failed. May be later .....



% Changes by Hossam Fahmy
%
% 1. I renamed the command to \rub instead of \arabmargin since I felt
% that arabmargin is too general for the specific task done here.
% 
% 2. At the end of the package, I used \allowarab{\rub} to allow the
% use of this command inside Arabic text.
%
% 3. I found that the marginal note is not justified because of the
% use of an arabic quotation (\RL) instead of an arabic environment
% (\begin{RLtext}). I made a new command \ARL that just puts things in
% an environemnt and changed the \RL into \ARL.
%
% 4. At the end of the \rub command, instead of making the status return to
% vocalize, I made a local \novocalize in the \ARL command mentioned
% above.
%
% 5. To make the marginal note appear ``on the same line'', I put it
% in a parbox and then used a raisebox command to raise it a bit. This
% is a temporary solution till we understand why it was lowered initialy. 



% changes by second Eygptain group
%




\ProvidesPackage{qamargin}[2006/07/04 v1.1 quran margin for hizb identifier]%remove "(pwd)"

\newcount\juz
\newcount\hizb
\newcount\fourth

\juz=1
\hizb=1
\fourth=2

\allowarab{\the}

% to avoid redefining a command, giving unexpected results
% use \newcommand instead of \def
\setlength{\fboxrule}{.7mm}

\newcommand{\ARL}[1]{\begin{RLtext}\novocalize#1\end{RLtext}}

\def\rubox{\leavevmode\hbox to0cm{\hspace*{ 2.1em}\vbox to0cm{% l2
	\vspace*{-5em}
     \framebox{%
       \vrule width2.5em height0em depth0em % l3
         \vrule width0em height0em depth3.5em % h3
      }\vss}\hss}}

\def\jabox{\leavevmode\hbox to0cm{\hspace*{ 1.7em}\vbox to0cm{% l2
	\vspace*{-3.8em}
     \framebox{%
       \vrule width3.5em height0em depth0em % l3
         \vrule width0em height0em depth2.5em % h3
      }\vss}\hss}}
      
\def\hzbox{\leavevmode\hbox to0cm{\hspace*{ 1.8em}\vbox to0cm{% l2
	\vspace*{-4.2em}
     \framebox{%
       \vrule width3em height0em depth0em % l3
         \vrule width0em height0em depth2.5em % h3
      }\vss}\hss}}
      
\def\thrbox{\leavevmode\hbox to0cm{\hspace*{2em}\vbox to0cm{% l2
	\vspace*{-5.2em}
     \framebox{%
       \vrule width2.7em height0em depth0em % l3
         \vrule width0em height0em depth3.6em % h3
      }\vss}\hss}}
      
\def\sajdahzbox{\leavevmode\hbox to0cm{\hspace*{ 2.2em}\vbox to0cm{% l2
	\vspace*{-5em}
     \framebox{%
       \vrule width2.7em height0em depth0em % l3
         \vrule width0em height0em depth3.5em % h3
      }\vss}\hss}}

\def\sajdarubox{\leavevmode\hbox to0cm{\hspace*{ 2.2em}\vbox to0cm{% l2
	\vspace*{-6em}
     \framebox{%
       \vrule width2.5em height0em depth0em % l3
         \vrule width0em height0em depth4.5em % h3
      }\vss}\hss}}
     

\def\sajdathrbox{\leavevmode\hbox to0cm{\hspace*{2em}\vbox to0cm{% l2
	\vspace*{-6.6em}
     \framebox{%
       \vrule width2.7em height0em depth0em % l3
         \vrule width0em height0em depth5.3em % h3
      }\vss}\hss}}
\global\newcommand{\rub}{%
	\digfalse
	\marginpar{\raisebox{3.6ex}[0pt][0pt]{\parbox[t]{7.1em}{%  
	\newcount\temp \temp=\fourth%
	\ifsajda\def\next{\sajdafalse%
	\ifcase\fourth%
	\or{%
		\ifodd\hizb%
		\else%
		\ARL{\hfill \smaller الحِزْبُ \hfill \\\hfill \n{\the\hizb}\hfill\\\hfill\s{\smaller سَـجدَة}\hfill}\sajdahzbox%
		\fi% end of ifodd
	}%
	\or{\ARL{\vskip -3ex\hfill \Smaller ربْع \hfill \\\hfill\larger الحِزب \hfill \\\hfill \n{\the\hizb}\hfill\\\hfill\s{\smaller سَـجدَة}\hfill}\sajdarubox}%
	\or
	\or{\ARL{\vskip -3ex\hfill\Smaller ثلاثة ارباعِ \hfill\\\hfill\larger الحِزب \hfill\\\hfill\n{\the\hizb}\hfill\\\hfill\s{\smaller سَـجدَة}\hfill}\sajdathrbox}%
	\fi% end of ifcase
	}\else\def\next{%
		\ifcase\fourth%
	\or{%
		\ifodd\hizb%
		\ARL{\hfill\smaller الـجُـزء \the\juz\hfill \\\hfill الحِزْبُ \n{\the\hizb}\hfill}\jabox%
		\else%
		\ARL{\hfill الحِزْبُ \hfill \\\hfill \n{\the\hizb}\hfill}\hzbox%
		\fi% end of ifodd
	}%
	\or{\ARL{\hfill \Smaller ربْع  \hfill \\\hfill \larger الحِزب \hfill \\\hfill \n{\the\hizb}\hfill}\rubox}
	\or{\ARL{\hfill\smaller نصْف \hfill \\\hfill الحِزب \hfill \\\hfill \n{\the\hizb}\hfill}\rubox}%
	\or{\ARL{\hfill \Smaller ثلاثة ارباعِ \hfill \\\hfill \larger الحِزب \hfill \\\hfill \n{\the\hizb}\hfill}\thrbox}%
	\fi% end of ifcase
	}\fi\next%
	\ifnum\hizb>60%
	\PackageError{hizbExceeded}{The number of hizb = \the\hizb. Pls correct it.}%
	{use less hizb}%
	\else%
	\fi% end of ifnum
	\advance \temp by 1%
	\global\fourth=\temp%
	\ifnum\fourth>4%
	\temp=\hizb%
	\advance \temp by 1%
	\global\hizb=\temp%
	\ifodd\hizb%
	\temp=\juz%
	\advance \temp by 1%
	\global\juz=\temp%
	\else%
	\fi% end of ifodd
	\global\fourth=1%
	\else%
	\fi% end of ifnum
}%
}}
%\digitstrue
\digtrue}% end of newcommand

\allowarab{\rub}

%%%%%%%%%%%%%%%%%%%%%%%% sajda %%%%%%%%%%%%%%%%%%%%%%%

%\newcommand{\sajda}{%   
%\marginpar{\raisebox{-.1ex}[0pt][0pt]{\parbox[t]{8mm}{%
% {\rlap {\hbox to 2.8ex{\ARL{\hfill \footnotesizeسَجْدَة \hfill}}\vbox to 2.9em{\ARL{\Huge{\char'305}}}}}}}}}
%\allowarab{\sajda}

\def\sajdabox{\leavevmode\hbox to0cm{\hspace*{ 2.2em}\vbox to0cm{% l2
	\vspace*{-2.5em}
     \framebox{%
       \vrule width2.5em height0em depth0em % l3
         \vrule width0em height0em depth1.2em % h3
      }\vss}\hss}}

\newcommand{\sajda}{%   
	\marginpar{\parbox[t]{7.2em}{% 
	\ARL{\hfill\smaller سَـجدَة\hfill}\sajdabox}}}
\allowarab{\sajda}
